<template>
  <div class="use-new-color-config">
    <video
      v-if="background.IsHidden"
      class="fixed right-0 z-0 min-w-full min-h-full max-w-none"
      autoplay
      muted
      loop
    >
      <source
        :src="
          getAssetImage(
            'assets/theme/light_flexible_1/desktop/images/login-register-bg.mp4'
          )
        "
        loading="lazy"
      />
    </video>
    <div v-else class="fixed right-0 min-w-full min-h-full z-1 max-w-none">
      <img class="w-screen h-screen" loading="lazy" :src="background.ImagePath" />
    </div>
    <main id="auth__main" class="flex items-center justify-center h-screen">
      <div class="flex justify-center">
        <div class="z-10 flex flex-col items-center login__content">
          <div v-if="!sponsorEnabled.IsHidden">
            <div
              class="flex justify-center items-center gap-4 mt-4 my-2 text-[14px]"
            >
              <div class="border-across-title">
                <span class="text-xs text-white">{{ $t("sponsors") }}</span>
              </div>
            </div>
            <div class="flex justify-between w-full px-4">
              <div
                v-for="sponsor in sponsors"
                :key="sponsor"
                class="flex flex-col items-center justify-center"
              >
                <img class="w-[58px]" loading="lazy" :src="sponsor.ImagePath" />
                <div class="text-center text-slate-300 text-[9px] justify-center">
                  {{ sponsor.Text }}
                </div>
              </div>
            </div>
          </div>
          <div class="w-[1200px] flex-none m-auto rounded-2xl overflow-hidden">
            <div class="h-[64px] bg-background5 flex justify-between items-center py-0 pl-[40px] pr-[16px]">
              <h1 class="text-left text-2xl font-semibold text-[var(--secondary)]">{{ $t('capital_login') }}</h1>
              <close-button />
            </div>
            <div class="w-full h-[2px] bg-border"></div>
            <el-col class="w-[400px] py-6 px-10 bg-background5 h-[654px] overflow-hidden">
              <el-form
                id="check-in-form"
                ref="loginFormRef"
                :model="loginFormData"
                :rules="loginRules"
              >
                <div class="flex flex-col gap-4">
                  <el-form-item class="input__container" prop="Username">
                    <el-input
                      class="text-[14px]"
                      v-model="loginFormData.Username"
                      :disabled="isLoginProccessing"
                      :placeholder="$t('username')"
                    >
                      <template #prefix>
                        <img
                          :src="
                            getAssetImage(
                              'assets/theme/light_flexible_1/desktop/images/user-icon.png'
                            )
                          "
                          loading="lazy"
                        />
                      </template>
                    </el-input>
                  </el-form-item>
                  <el-form-item class="input__container" prop="Password">
                    <el-input
                      v-model="loginFormData.Password"
                      :disabled="isLoginProccessing"
                      class="bg-transparent text-[14px]"
                      id="passwd"
                      type="password"
                      :placeholder="$t('password')"
                    >
                      <template #prefix>
                        <img
                          :src="
                            getAssetImage(
                              'assets/theme/light_flexible_1/desktop/images/lock-icon.png'
                            )
                          "
                          loading="lazy"
                        />
                      </template>
                    </el-input>
                  </el-form-item>
                  <el-divider class="bg-border" />
                  <el-form-item v-if="!clientCaptcha.IsHidden" prop="Captcha">
                    <div class="captcha__container">
                      <div class="flex items-center w-full">
                        <template
                          v-if="
                            !captchaErrorMsg.length &&
                            loginFormData.Captcha.length == 5 &&
                            !isDialogVisible
                          "
                        >
                          <div class="h-[25px] w-[25px]">
                            <img
                              :src="
                                getAssetImage(
                                  'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                                )
                              "
                              alt=""
                              loading="lazy"
                            />
                          </div>
                          <div class="text-white truncate text-click-to-verify">
                            {{ $t("successful_verification") }}
                          </div>
                        </template>
                        <template v-else>
                          <div
                            class="flex items-center w-full"
                            @click="isDialogVisible = true"
                          >
                            <div class="h-[25px] w-[25px]">
                              <img
                                :src="
                                  getAssetImage(
                                    'assets/theme/light_flexible_1/desktop/images/verify-icon.png'
                                  )
                                "
                                alt=""
                                loading="lazy"
                              />
                            </div>
                            <div class="text-white truncate text-click-to-verify">
                              {{ $t("click_to_verify") }}
                            </div>
                          </div>
                        </template>
                      </div>
                    </div>
                  </el-form-item>
                  <el-button
                    @click="submitLogin(loginFormRef)"
                    :loading="isLoginProccessing"
                    class="input__container"
                    >{{ $t("capital_login") }}</el-button
                  >
                  <el-form-item class="forgot-password-form-item gap-0">
                    <auth-forgot-password-modal />
                  </el-form-item>
                  <div v-if="!register.IsHidden" class="flex text5 w-full text-[14px] gap-1">
                    {{ $t('dont_have_an_account?') }}
                    <span class="text-inherit">
                      <nuxt-link
                        class="text-primary underline cursor-pointer"
                        to="/register"
                        :id="ID.SIGNUP"
                        >{{ $t("joinnow") }}
                      </nuxt-link>
                    </span> |
                    <span class="text-primary underline cursor-pointer" @click="goHome">
                      {{ $t("skip_login") }}
                    </span>
                  </div>
                </div>
              </el-form>
            </el-col>
            <el-col class="relative register-info w-[800px] h-[654px] flex flex-col justify-center text-center ol-bg-light">
              <div class="text-center">
                <div class="w-[752px] h-[504px]">
                  <img :src="loginRegister.ImagePath" class="w-full h-full object-contain" />
                </div>
                <div class="text-primary text-2xl font-black mb-1">
                  <span>{{ $t('welcome_to') }}</span>
                  <span v-if="!companyName.IsHidden" class="font-black text-[32px] fc-text4 ml-1">{{ companyName.Text }}</span>
                </div>
                <div class="text-base fc-text4">{{ $t(loginRegister.Text) }}</div>
              </div>
            </el-col>
          </div>
        </div>
      </div>
    </main>
    <el-dialog
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      v-model="isDialogVisible"
      width="320px"
      @open="loginFormData.Captcha = ''"
      @close="loginFormRef?.validateField('Captcha')"
    >
      <utils-client-captcha
        v-if="!clientCaptcha.IsHidden"
        v-model:captcha="loginFormData.Captcha"
        v-model:dialogVisible="isDialogVisible"
        :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import useLogin from "@/composables/useLogin";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { clientCaptcha } from "@/composables/captcha/useCaptcha";
import { store } from "~~/store";

export default defineComponent({
  name: "Login",
  setup() {
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const { getAssetImage } = commonHelper;
    const router = useRouter();
    const sponsorEnabled = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_1"
        )
    );
    const sponsors = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          "index_blog_1_"
        )
    );
    const background = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "background_image"
        )
    );
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "logo"
        )
    );
    const companyName = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register_company_name"
      )
    );
    const { ...prop } = useLogin();
    function addMinutes(numOfMinutes: number, date = new Date()) {
      date.setMinutes(date.getMinutes() + numOfMinutes);
      return date;
    }
    const goHome = () => {
      document.cookie = `skipLogin=true;expires=${addMinutes(10)};path=/`;
      router.replace("/");
    };
    const isDialogVisible = ref(false);
    const loginRegister = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register"
      )
    );
    return {
      ...prop,
      sponsors,
      sponsorEnabled,
      logo,
      goHome,
      clientCaptcha,
      isDialogVisible,
      getAssetImage,
      background,
      loginRegister,
      companyName,
    };
  },
});
</script>
<style scoped>
.register-info {
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
}
.captcha__container {
  display: flex;
  border-radius: 20px;
  line-height: 44px;
  height: 40px;
  width: 100%;
  box-shadow: inset 0 1px 15px 0 #fff;
  background-color: rgba(255, 255, 255, 0.5);
  align-items: center;
  color: #fff !important;
  padding-left: 12px;
}
.login{
  display: block;
}
.el-form-item {
  display: block;
  margin-bottom: 16px;
}
.text-primary {
  color: var(--primary);
}
.el-button.is-round {
  border-radius: 4px;
}
:deep(.forgot-password-form-item .el-form-item__content) {
  margin: 0;
  justify-content: center;
  margin-top: 10px;
  line-height: 0;
}
:deep(.el-form-item__label) {
  color: var(--text5);
}
.el-divider--horizontal{
  margin: 0;
}
:deep(.el-button.input__container) {
  background: var(--secondary);
}
:deep(.el-dialog__header) {
  padding: unset;
}
[layout="china"] .china-login-color-config-v2 {
  --background5: var(--background5-new);
  --text5: var(--text5-new);
}
</style>
<style lang="scss">
.login__content {
  .input__container {
    .el-input {
      box-shadow: none;
      border: solid 1px var(--border);
      background: var(--background5);
    }
  }
  .el-input__inner {
    color: var(--text5);
    &::placeholder {
      color: var(--text5);
      opacity: 0.5;
    }
  }
  .text5 {
    color: var(--text5);
  }
}
</style>
